<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: Moco Utilities</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('group__mocoutil.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">Moco Utilities</div>  </div>
</div><!--header-->
<div class="contents">

<p>These are free functions and utility classes in the Moco library.  
<a href="#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1FileDeletionThrowerException.html">OpenSim::FileDeletionThrowerException</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Thrown by <a class="el" href="classOpenSim_1_1FileDeletionThrower.html#a5b50499e531b31c34a959d0c394f4767">FileDeletionThrower::throwIfDeleted()</a>.  <a href="classOpenSim_1_1FileDeletionThrowerException.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1FileDeletionThrower.html">OpenSim::FileDeletionThrower</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">This class helps a user cause an exception within the code.  <a href="classOpenSim_1_1FileDeletionThrower.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:gaa25a9ebdb9e76257d6c73f4285dc34f2"><td class="memTemplParams" colspan="2">template&lt;typename T &gt; </td></tr>
<tr class="memitem:gaa25a9ebdb9e76257d6c73f4285dc34f2"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classOpenSim_1_1TimeSeriesTable__.html">TimeSeriesTable_</a>&lt; T &gt;&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group__mocoutil.html#gaa25a9ebdb9e76257d6c73f4285dc34f2">OpenSim::analyzeMocoTrajectory</a> (<a class="el" href="classOpenSim_1_1Model.html">Model</a> model, const <a class="el" href="classOpenSim_1_1MocoTrajectory.html">MocoTrajectory</a> &amp;trajectory, const std::vector&lt; std::string &gt; &amp;outputPaths)</td></tr>
<tr class="memdesc:gaa25a9ebdb9e76257d6c73f4285dc34f2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculate the requested outputs using the model in the problem and the provided <a class="el" href="classOpenSim_1_1StatesTrajectory.html">StatesTrajectory</a> and controls table.  <a href="group__mocoutil.html#gaa25a9ebdb9e76257d6c73f4285dc34f2">More...</a><br /></td></tr>
<tr class="separator:gaa25a9ebdb9e76257d6c73f4285dc34f2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga8a5e23c1b04a1ceed9643401d84faf0d"><td class="memItemLeft" align="right" valign="top">OSIMMOCO_API void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__mocoutil.html#ga8a5e23c1b04a1ceed9643401d84faf0d">OpenSim::prescribeControlsToModel</a> (const <a class="el" href="classOpenSim_1_1MocoTrajectory.html">MocoTrajectory</a> &amp;trajectory, <a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;model, std::string functionType=&quot;GCVSpline&quot;)</td></tr>
<tr class="memdesc:ga8a5e23c1b04a1ceed9643401d84faf0d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Given a <a class="el" href="classOpenSim_1_1MocoTrajectory.html" title="The values of the variables in an optimal control problem.">MocoTrajectory</a> and the associated <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> model, return the model with a prescribed controller appended that will compute the control values from the <a class="el" href="classOpenSim_1_1MocoTrajectory.html" title="The values of the variables in an optimal control problem.">MocoTrajectory</a>.  <a href="group__mocoutil.html#ga8a5e23c1b04a1ceed9643401d84faf0d">More...</a><br /></td></tr>
<tr class="separator:ga8a5e23c1b04a1ceed9643401d84faf0d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gadde27ab82eb3eba8f7c43c52b79fb156"><td class="memItemLeft" align="right" valign="top">OSIMMOCO_API <a class="el" href="classOpenSim_1_1MocoTrajectory.html">MocoTrajectory</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__mocoutil.html#gadde27ab82eb3eba8f7c43c52b79fb156">OpenSim::simulateTrajectoryWithTimeStepping</a> (const <a class="el" href="classOpenSim_1_1MocoTrajectory.html">MocoTrajectory</a> &amp;trajectory, <a class="el" href="classOpenSim_1_1Model.html">Model</a> model, double integratorAccuracy=SimTK::NaN)</td></tr>
<tr class="memdesc:gadde27ab82eb3eba8f7c43c52b79fb156"><td class="mdescLeft">&#160;</td><td class="mdescRight">Use the controls and initial state in the provided trajectory to simulate the model using an ODE time stepping integrator (<a class="el" href="classOpenSim_1_1Manager.html" title="A class that manages the execution of a simulation.">OpenSim::Manager</a>), and return the resulting states and controls.  <a href="group__mocoutil.html#gadde27ab82eb3eba8f7c43c52b79fb156">More...</a><br /></td></tr>
<tr class="separator:gadde27ab82eb3eba8f7c43c52b79fb156"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga2a8c0203ebf6babc23168bc4cd76fa68"><td class="memItemLeft" align="right" valign="top">OSIMMOCO_API <a class="el" href="classOpenSim_1_1MocoTrajectory.html">MocoTrajectory</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__mocoutil.html#ga2a8c0203ebf6babc23168bc4cd76fa68">OpenSim::createPeriodicTrajectory</a> (const <a class="el" href="classOpenSim_1_1MocoTrajectory.html">MocoTrajectory</a> &amp;halfPeriodTrajectory, std::vector&lt; std::string &gt; addPatterns={&quot;.*pelvis_tx/value&quot;}, std::vector&lt; std::string &gt; negatePatterns={ &quot;.*pelvis_list(?!/value).*&quot;, &quot;.*pelvis_rotation.*&quot;, &quot;.*pelvis_tz(?!/value).*&quot;, &quot;.*lumbar_bending(?!/value).*&quot;, &quot;.*lumbar_rotation.*&quot;}, std::vector&lt; std::string &gt; negateAndShiftPatterns={ &quot;.*pelvis_list/value&quot;, &quot;.*pelvis_tz/value&quot;, &quot;.*lumbar_bending/value&quot;}, std::vector&lt; std::pair&lt; std::string, std::string &gt;&gt; symmetryPatterns={{R&quot;(_r(\/|_|$))&quot;, &quot;_l$1&quot;}, {R&quot;(_l(\/|_|$))&quot;, &quot;_r$1&quot;}})</td></tr>
<tr class="memdesc:ga2a8c0203ebf6babc23168bc4cd76fa68"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert a trajectory covering half the period of a symmetric motion into a trajectory over the full period.  <a href="group__mocoutil.html#ga2a8c0203ebf6babc23168bc4cd76fa68">More...</a><br /></td></tr>
<tr class="separator:ga2a8c0203ebf6babc23168bc4cd76fa68"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga30ea0f4e9e9582c60e5dfba9c10254fe"><td class="memItemLeft" align="right" valign="top">OSIMMOCO_API int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__mocoutil.html#ga30ea0f4e9e9582c60e5dfba9c10254fe">OpenSim::getMocoParallelEnvironmentVariable</a> ()</td></tr>
<tr class="memdesc:ga30ea0f4e9e9582c60e5dfba9c10254fe"><td class="mdescLeft">&#160;</td><td class="mdescRight">This obtains the value of the OPENSIM_MOCO_PARALLEL environment variable.  <a href="group__mocoutil.html#ga30ea0f4e9e9582c60e5dfba9c10254fe">More...</a><br /></td></tr>
<tr class="separator:ga30ea0f4e9e9582c60e5dfba9c10254fe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gafe5751c42bc6997f76768ee9cb20323f"><td class="memItemLeft" align="right" valign="top">OSIMMOCO_API <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__mocoutil.html#gafe5751c42bc6997f76768ee9cb20323f">OpenSim::createExternalLoadsTableForGait</a> (<a class="el" href="classOpenSim_1_1Model.html">Model</a> model, const <a class="el" href="classOpenSim_1_1StatesTrajectory.html">StatesTrajectory</a> &amp;trajectory, const std::vector&lt; std::string &gt; &amp;forcePathsRightFoot, const std::vector&lt; std::string &gt; &amp;forcePathsLeftFoot)</td></tr>
<tr class="memdesc:gafe5751c42bc6997f76768ee9cb20323f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Obtain the ground reaction forces, centers of pressure, and torques resulting from <a class="el" href="classOpenSim_1_1Force.html" title="This abstract class represents a force applied to bodies or generalized coordinates during a simulati...">Force</a> elements (e.g., <a class="el" href="classOpenSim_1_1SmoothSphereHalfSpaceForce.html" title="This compliant contact force model is similar to HuntCrossleyForce, except that this model applies fo...">SmoothSphereHalfSpaceForce</a>), using a model and states trajectory.  <a href="group__mocoutil.html#gafe5751c42bc6997f76768ee9cb20323f">More...</a><br /></td></tr>
<tr class="separator:gafe5751c42bc6997f76768ee9cb20323f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaf1835ac7c83327eb5956922a9626d94a"><td class="memItemLeft" align="right" valign="top">OSIMMOCO_API <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__mocoutil.html#gaf1835ac7c83327eb5956922a9626d94a">OpenSim::createExternalLoadsTableForGait</a> (<a class="el" href="classOpenSim_1_1Model.html">Model</a> model, const <a class="el" href="classOpenSim_1_1MocoTrajectory.html">MocoTrajectory</a> &amp;trajectory, const std::vector&lt; std::string &gt; &amp;forcePathsRightFoot, const std::vector&lt; std::string &gt; &amp;forcePathsLeftFoot)</td></tr>
<tr class="memdesc:gaf1835ac7c83327eb5956922a9626d94a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Same as above, but with a <a class="el" href="classOpenSim_1_1MocoTrajectory.html" title="The values of the variables in an optimal control problem.">MocoTrajectory</a> instead of a <a class="el" href="classOpenSim_1_1StatesTrajectory.html">StatesTrajectory</a>.  <a href="group__mocoutil.html#gaf1835ac7c83327eb5956922a9626d94a">More...</a><br /></td></tr>
<tr class="separator:gaf1835ac7c83327eb5956922a9626d94a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<p>These are free functions and utility classes in the Moco library. </p>
<h2 class="groupheader">Function Documentation</h2>
<a id="gaa25a9ebdb9e76257d6c73f4285dc34f2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gaa25a9ebdb9e76257d6c73f4285dc34f2">&#9670;&nbsp;</a></span>analyzeMocoTrajectory()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1TimeSeriesTable__.html">TimeSeriesTable_</a>&lt;T&gt; OpenSim::analyzeMocoTrajectory </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1Model.html">Model</a>&#160;</td>
          <td class="paramname"><em>model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1MocoTrajectory.html">MocoTrajectory</a> &amp;&#160;</td>
          <td class="paramname"><em>trajectory</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; std::string &gt; &amp;&#160;</td>
          <td class="paramname"><em>outputPaths</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Calculate the requested outputs using the model in the problem and the provided <a class="el" href="classOpenSim_1_1StatesTrajectory.html">StatesTrajectory</a> and controls table. </p>
<p>The controls table is used to set the model's controls vector. We assume the <a class="el" href="classOpenSim_1_1StatesTrajectory.html">StatesTrajectory</a> and controls table contain the same time points. The output paths can be regular expressions. For example, ".*activation" gives the activation of all muscles.</p>
<p>The output paths must correspond to outputs that match the type provided in the template argument, otherwise they are not included in the report.</p>
<dl class="section note"><dt>Note</dt><dd>The provided trajectory is not modified to satisfy kinematic constraints, but SimTK::Motions in the <a class="el" href="classOpenSim_1_1Model.html" title="A concrete class that specifies the interface to a musculoskeletal model.">Model</a> (e.g., <a class="el" href="classOpenSim_1_1PositionMotion.html" title="This class prescribes the value, speed, and acceleration of all coordinates in the model using SimTK:...">PositionMotion</a>) are applied. Therefore, this function expects that you've provided a trajectory that already satisfies kinematic constraints. If your provided trajectory does not satisfy kinematic constraints, many outputs will be incorrect. For example, in a model with a patella whose location is determined by a <a class="el" href="classOpenSim_1_1CoordinateCouplerConstraint.html">CoordinateCouplerConstraint</a>, the length of a muscle that crosses the patella will be incorrect.</dd>
<dd>
Parameters and Lagrange multipliers in the <a class="el" href="classOpenSim_1_1MocoTrajectory.html" title="The values of the variables in an optimal control problem.">MocoTrajectory</a> are <b>not</b> applied to the model. </dd></dl>

<p class="reference">References <a class="el" href="classOpenSim_1_1MocoTrajectory.html#a74aa130e757fcef4c1a17c2a3e64f727">OpenSim::MocoTrajectory::exportToControlsTable()</a>, <a class="el" href="classOpenSim_1_1MocoTrajectory.html#ab7e4d61998f149520df2dc4ed3919913">OpenSim::MocoTrajectory::exportToDerivativesWithoutAccelerationsTable()</a>, and <a class="el" href="classOpenSim_1_1MocoTrajectory.html#a0399614d7a13743b0290136c0f14e020">OpenSim::MocoTrajectory::exportToStatesTable()</a>.</p>

</div>
</div>
<a id="gaf1835ac7c83327eb5956922a9626d94a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gaf1835ac7c83327eb5956922a9626d94a">&#9670;&nbsp;</a></span>createExternalLoadsTableForGait() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMMOCO_API <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> OpenSim::createExternalLoadsTableForGait </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1Model.html">Model</a>&#160;</td>
          <td class="paramname"><em>model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1MocoTrajectory.html">MocoTrajectory</a> &amp;&#160;</td>
          <td class="paramname"><em>trajectory</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; std::string &gt; &amp;&#160;</td>
          <td class="paramname"><em>forcePathsRightFoot</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; std::string &gt; &amp;&#160;</td>
          <td class="paramname"><em>forcePathsLeftFoot</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Same as above, but with a <a class="el" href="classOpenSim_1_1MocoTrajectory.html" title="The values of the variables in an optimal control problem.">MocoTrajectory</a> instead of a <a class="el" href="classOpenSim_1_1StatesTrajectory.html">StatesTrajectory</a>. </p>

</div>
</div>
<a id="gafe5751c42bc6997f76768ee9cb20323f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gafe5751c42bc6997f76768ee9cb20323f">&#9670;&nbsp;</a></span>createExternalLoadsTableForGait() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMMOCO_API <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> OpenSim::createExternalLoadsTableForGait </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1Model.html">Model</a>&#160;</td>
          <td class="paramname"><em>model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1StatesTrajectory.html">StatesTrajectory</a> &amp;&#160;</td>
          <td class="paramname"><em>trajectory</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; std::string &gt; &amp;&#160;</td>
          <td class="paramname"><em>forcePathsRightFoot</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; std::string &gt; &amp;&#160;</td>
          <td class="paramname"><em>forcePathsLeftFoot</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Obtain the ground reaction forces, centers of pressure, and torques resulting from <a class="el" href="classOpenSim_1_1Force.html" title="This abstract class represents a force applied to bodies or generalized coordinates during a simulati...">Force</a> elements (e.g., <a class="el" href="classOpenSim_1_1SmoothSphereHalfSpaceForce.html" title="This compliant contact force model is similar to HuntCrossleyForce, except that this model applies fo...">SmoothSphereHalfSpaceForce</a>), using a model and states trajectory. </p>
<p>Forces and torques are expressed in the ground frame with respect to the ground origin. Hence, the centers of pressure are at the origin. Paths to <a class="el" href="classOpenSim_1_1Force.html" title="This abstract class represents a force applied to bodies or generalized coordinates during a simulati...">Force</a> elements should be provided separately for elements of the right and left feet. The output is a table formatted for use with <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> tools; the labels of the columns distinguish between right ("&lt;&gt;_r") and left ("&lt;&gt;_l") forces, centers of pressure, and torques. The forces and torques used are taken from the first six outputs of getRecordValues(); this order is of use for, for example, the <a class="el" href="classOpenSim_1_1SmoothSphereHalfSpaceForce.html" title="This compliant contact force model is similar to HuntCrossleyForce, except that this model applies fo...">SmoothSphereHalfSpaceForce</a> contact model but might have a different meaning for different contact models. </p>
<dl class="section examples"><dt>Examples</dt><dd><a class="el" href="example2DWalking_8cpp-example.html#a3">example2DWalking.cpp</a>, and <a class="el" href="example2DWalking_8m-example.html#a2">example2DWalking.m</a>.</dd>
</dl>

</div>
</div>
<a id="ga2a8c0203ebf6babc23168bc4cd76fa68"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga2a8c0203ebf6babc23168bc4cd76fa68">&#9670;&nbsp;</a></span>createPeriodicTrajectory()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMMOCO_API <a class="el" href="classOpenSim_1_1MocoTrajectory.html">MocoTrajectory</a> OpenSim::createPeriodicTrajectory </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1MocoTrajectory.html">MocoTrajectory</a> &amp;&#160;</td>
          <td class="paramname"><em>halfPeriodTrajectory</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::vector&lt; std::string &gt;&#160;</td>
          <td class="paramname"><em>addPatterns</em> = <code>{&quot;.*pelvis_tx/value&quot;}</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::vector&lt; std::string &gt;&#160;</td>
          <td class="paramname"><em>negatePatterns</em> = <code>{&#160;&quot;.*pelvis_list(?!/value).*&quot;,&#160;&quot;.*pelvis_rotation.*&quot;,&#160;&quot;.*pelvis_tz(?!/value).*&quot;,&#160;&quot;.*lumbar_bending(?!/value).*&quot;,&#160;&quot;.*lumbar_rotation.*&quot;}</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::vector&lt; std::string &gt;&#160;</td>
          <td class="paramname"><em>negateAndShiftPatterns</em> = <code>{&#160;&quot;.*pelvis_list/value&quot;,&#160;&quot;.*pelvis_tz/value&quot;,&#160;&quot;.*lumbar_bending/value&quot;}</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::vector&lt; std::pair&lt; std::string, std::string &gt;&gt;&#160;</td>
          <td class="paramname"><em>symmetryPatterns</em> = <code>{{R&quot;(_r(\/|_|$))&quot;,&#160;&quot;_l$1&quot;},&#160;{R&quot;(_l(\/|_|$))&quot;,&#160;&quot;_r$1&quot;}}</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Convert a trajectory covering half the period of a symmetric motion into a trajectory over the full period. </p>
<p>This is useful for simulations of half a gait cycle. This converts time, states, controls, and derivatives; all other quantities from the input trajectory are ignored. If a column in the trajectory does not match addPatterns, negatePatterns, negateAndShiftPatterns, or symmetryPatterns, then the second half of the period contains the same data as the first half.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">halfPeriodTrajectory</td><td>The input trajectory covering half a period. </td></tr>
    <tr><td class="paramname">addPatterns</td><td>If a column label matches an addPattern, then the second half of the period for that column is (first_half_trajectory + half_period_value - initial_value). </td></tr>
    <tr><td class="paramname">negatePatterns</td><td>If a column label matches a negatePattern, then the second half of the period for that column is (-first_half_trajectory). This is usually relevant for only 3D models. </td></tr>
    <tr><td class="paramname">negateAndShiftPatterns</td><td>If a column label matches a negateAndShiftPattern, then the second half of the period for that column is (-first_half_trajectory + 2 * half_period_value). This is usually relevant for only 3D models. </td></tr>
    <tr><td class="paramname">symmetryPatterns</td><td>This argument is a list of pairs, where the first element of the pair is a pattern to match, and the second is a substitution to convert the column label into the opposite column label of the symmetric pair. If a column label matches a symmetryPattern, then its first half-period is copied into the second half of the period for the column identified by the substitution.</td></tr>
  </table>
  </dd>
</dl>
<p>The default values for the patterns are intended to handle the column labels for typical 2D or 3D <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> gait models. The default values for negatePatterns, negateAndShiftPatterns, and symmetryPatterns warrant an explanation. The string pattern before the regex "(?!/value)" is followed by anything except "/value" since it is contained in the negative lookahead "(?!...)". R"()" is a string literal that permits us to not escape backslash characters. The regex "_r(\/|_|$)" matches "_r" followed by either a forward slash (which is escaped), an underscore, OR the end of the string ($). Since the forward slash and end of the string are within parentheses, whatever matches this is captured and is available in the substitution (the second element of the pair) as $1. The default symmetry patterns cause the following replacements:</p><ul>
<li>"/jointset/hip_r/hip_flexion_r/value" becomes "/jointset/hip_l/hip_flexion_l/value"</li>
<li>"/forceset/soleus_r" becomes "/forceset/soleus_l" </li>
</ul>
<dl class="section examples"><dt>Examples</dt><dd><a class="el" href="example2DWalking_8cpp-example.html#a1">example2DWalking.cpp</a>, <a class="el" href="example2DWalking_8m-example.html#a1">example2DWalking.m</a>, and <a class="el" href="example2DWalkingMetabolics_8cpp-example.html#a1">example2DWalkingMetabolics.cpp</a>.</dd>
</dl>

</div>
</div>
<a id="ga30ea0f4e9e9582c60e5dfba9c10254fe"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga30ea0f4e9e9582c60e5dfba9c10254fe">&#9670;&nbsp;</a></span>getMocoParallelEnvironmentVariable()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMMOCO_API int OpenSim::getMocoParallelEnvironmentVariable </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This obtains the value of the OPENSIM_MOCO_PARALLEL environment variable. </p>
<p>The value has the following meanings:</p><ul>
<li>0: run in series (not parallel).</li>
<li>1: run in parallel using all cores.</li>
<li>greater than 1: run in parallel with this number of parallel jobs. If the environment variable is not set, this function returns -1.</li>
</ul>
<p>This variable does not indicate which calculations are parallelized or how the parallelization is achieved. Moco may even ignore or override the setting from the environment variable. See documentation elsewhere (e.g., from a specific <a class="el" href="classOpenSim_1_1MocoSolver.html" title="Once the solver is created, you should not make any edits to the MocoProblem.">MocoSolver</a>) for more information. </p>

</div>
</div>
<a id="ga8a5e23c1b04a1ceed9643401d84faf0d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga8a5e23c1b04a1ceed9643401d84faf0d">&#9670;&nbsp;</a></span>prescribeControlsToModel()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMMOCO_API void OpenSim::prescribeControlsToModel </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1MocoTrajectory.html">MocoTrajectory</a> &amp;&#160;</td>
          <td class="paramname"><em>trajectory</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;&#160;</td>
          <td class="paramname"><em>model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>functionType</em> = <code>&quot;GCVSpline&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Given a <a class="el" href="classOpenSim_1_1MocoTrajectory.html" title="The values of the variables in an optimal control problem.">MocoTrajectory</a> and the associated <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> model, return the model with a prescribed controller appended that will compute the control values from the <a class="el" href="classOpenSim_1_1MocoTrajectory.html" title="The values of the variables in an optimal control problem.">MocoTrajectory</a>. </p>
<p>This can be useful when computing state-dependent model quantities that require realization to the Dynamics stage or later. The function used to fit the controls can either be <a class="el" href="classOpenSim_1_1GCVSpline.html" title="A class for representing a smooth function with a generalized cross-validation spline.">GCVSpline</a> or <a class="el" href="classOpenSim_1_1PiecewiseLinearFunction.html" title="A class implementing a linear function.">PiecewiseLinearFunction</a>. </p>

</div>
</div>
<a id="gadde27ab82eb3eba8f7c43c52b79fb156"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gadde27ab82eb3eba8f7c43c52b79fb156">&#9670;&nbsp;</a></span>simulateTrajectoryWithTimeStepping()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OSIMMOCO_API <a class="el" href="classOpenSim_1_1MocoTrajectory.html">MocoTrajectory</a> OpenSim::simulateTrajectoryWithTimeStepping </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1MocoTrajectory.html">MocoTrajectory</a> &amp;&#160;</td>
          <td class="paramname"><em>trajectory</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1Model.html">Model</a>&#160;</td>
          <td class="paramname"><em>model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>integratorAccuracy</em> = <code>SimTK::NaN</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Use the controls and initial state in the provided trajectory to simulate the model using an ODE time stepping integrator (<a class="el" href="classOpenSim_1_1Manager.html" title="A class that manages the execution of a simulation.">OpenSim::Manager</a>), and return the resulting states and controls. </p>
<p>We return a <a class="el" href="classOpenSim_1_1MocoTrajectory.html" title="The values of the variables in an optimal control problem.">MocoTrajectory</a> (rather than a <a class="el" href="classOpenSim_1_1StatesTrajectory.html">StatesTrajectory</a>) to facilitate comparing optimal control solutions with time stepping. Use integratorAccuracy to override the default setting.</p>
<dl class="section note"><dt>Note</dt><dd>This function expects all <a class="el" href="classOpenSim_1_1Actuator.html" title="Base class for an actuator (e.g., a torque motor, muscle, ...) that requires a generic external input...">Actuator</a>s in the model to be in the <a class="el" href="classOpenSim_1_1Model.html" title="A concrete class that specifies the interface to a musculoskeletal model.">Model</a>'s <a class="el" href="classOpenSim_1_1ForceSet.html" title="A class for holding and managing a set of forces for a model.">ForceSet</a>. </dd></dl>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:16 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
